## termusic-0.12.0-1.src.tar.gz

=== Makefile ===
prog := termusic
server :=termusic-server
ifeq ($(OS),Windows_NT)
# Windows 
	prog := termusic.exe
	server := termusic-server.exe 
endif
default_cargo_home = $(HOME)/.local/share/cargo
# define CARGO_HOME if not defined
ifndef CARGO_HOME
	CARGO_HOME=$(default_cargo_home)
endif
# needs to be after CARGO_HOME, otherwise the default is not ever added
install_to = $(CARGO_HOME)/bin

ifeq ($(OS),Windows_NT)
	install_to = $(USERPROFILE)\.cargo\bin
endif

default: fmt 

fmt:
	cargo fmt --all
	cargo check --all --features cover,all-backends
	cargo clippy --all --features cover,all-backends
	# cargo clippy -- -D warnings

run: 
	cargo run 

# default backend, default features
release:
	cargo build --release --all

# backends + cover

rusty:
	cargo build --features cover --release --all

mpv:
	# disable "rusty" backend default
	cargo build --no-default-features --features cover,mpv --release --all

gst:
	# disable "rusty" backend default
	cargo build --no-default-features --features cover,gst --release --all

all-backends:
	cargo build  --features cover,all-backends --release --all

all-backends-test:
	cargo build  --features cover,all-backends --all

test: 
	cargo test --features cover,all-backends --release --all

# end backends + cover

full: all-backends post

minimal: release post

post: 
	echo $(install_to)
	cp -f target/release/$(prog) "$(install_to)"
	cp -f target/release/$(server) "$(install_to)"

install: release post

win:
	cargo build --all

winrelease:
	cargo build --release --all

winpost:
	powershell -noprofile -command "Write-Host $(install_to)"
	cp -f target/release/$(prog) "$(install_to)"
	cp -f target/release/$(server) "$(install_to)"

wininstall: winrelease winpost

wintest: win winpost

fulltest: all-backends-test post

=== PKGBUILD ===
# Maintainer: orhun <orhunparmaksiz@gmail.com>
# https://github.com/orhun/pkgbuilds

pkgname=termusic
pkgver=0.12.0
pkgrel=1
pkgdesc="Music Player TUI written in Rust"
arch=('x86_64')
url="https://github.com/tramhao/termusic"
license=('MIT' 'GPL3')
depends=('gstreamer' 'gst-plugins-base' 'gst-plugins-good' 'gst-plugins-bad' 'gst-plugins-ugly' 'gst-libav' 'dbus' 'ueberzug' 'libsixel' 'libmpv.so')
optdepends=('yt-dlp: download mp3'
  'ffmpeg: download mp3'
  'emoji-font: for displaying emojis')
makedepends=('cargo' 'clang' 'protobuf')
source=("$pkgname-$pkgver.tar.gz::$url/archive/v$pkgver.tar.gz")
sha512sums=('bb76a5db39bb1eeedf0ed834f41bdc97d2e49baadd6dc938f275edac95d73674a316747c498b11e970336f2b47eba5439a6c23f03557dec334b081fa25e117e9')
options=('!lto')

prepare() {
  cd "$pkgname-$pkgver"
  cargo fetch --locked --target "$(rustc -vV | sed -n 's/host: //p')"
}

build() {
  cd "$pkgname-$pkgver"
  cargo build --features cover,all-backends --release --frozen
}

check() {
  cd "$pkgname-$pkgver"
  cargo test --frozen
}

package() {
  cd "$pkgname-$pkgver"
  install -Dm 755 "target/release/$pkgname" -t "$pkgdir/usr/bin"
  install -Dm 755 "target/release/$pkgname-server" -t "$pkgdir/usr/bin"
  install -Dm 644 README.md -t "$pkgdir/usr/share/doc/$pkgname"
  install -Dm 644 LICENSE_MIT -t "$pkgdir/usr/share/licenses/$pkgname"
}
